/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package FunctionLayer;

import PresentationLayer.DiscordHandler;
import discord4j.core.event.domain.message.MessageCreateEvent;
import discord4j.core.object.entity.User;
import discord4j.core.object.entity.channel.TextChannel;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import edu.stanford.nlp.pipeline.StanfordCoreNLP;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;


/**
 * @author install1
 */
public class DoStuff {


    public static void doStuff(MessageCreateEvent event, String usernameBot, Datahandler datahandler,
                               StanfordCoreNLP stanfordCoreNLP, StanfordCoreNLP stanfordCoreNLPSentiment) {
        String username = "";
        try {
            username = event.getMessage().getAuthor().get().getUsername();
        } catch (java.util.NoSuchElementException e) {
            username = null;
        }
        if (username != null && !username.equals(usernameBot)) {
            TextChannel block = event.getMessage().getChannel().cast(TextChannel.class).block();
            String name = block.getCategory().block().getName();
            name = name.toLowerCase();
            String channelName = block.getName().toLowerCase();
            boolean channelpermissionsDenied = false;
            if (channelName.contains("suggestion-box")) {
                channelpermissionsDenied = true;
            }
            switch (name) {
                case "public area":
                case "information area": {
                    break;
                }
                default: {
                    channelpermissionsDenied = true;
                    break;
                }
            }
            if (!channelpermissionsDenied) {
                List<User> blockLast = event.getMessage().getUserMentions().buffer().blockLast();
                String content = event.getMessage().getContent();
                if (blockLast != null) {
                    for (User user : blockLast) {
                        content = content.replace(user.getId().asString(), "");
                    }
                }
                boolean mentionedBot = false;
                if (blockLast != null) {
                    for (User user : blockLast) {
                        if (user.getUsername().equals(usernameBot)) {
                            mentionedBot = true;
                            break;
                        }
                    }
                }
                if (mentionedBot || channelName.contains("general-autism")) {
                    String ResponseStr;
                    ResponseStr = datahandler.getResponseMsg(content, username, stanfordCoreNLP, stanfordCoreNLPSentiment,
                            false);
                    if (!ResponseStr.isEmpty()) {
                        System.out.print("\nResponseStr3: " + ResponseStr + "\n");
                        event.getMessage().getChannel().block().createMessage(ResponseStr).block();
                    }
                }
            }
            datahandler.updateStringCache();
        }
    }
}
